# coding: utf-8

"""
    Elastic Email REST API

    This API is based on the REST API architecture, allowing the user to easily manage their data with this resource-based approach.    Every API call is established on which specific request type (GET, POST, PUT, DELETE) will be used.    The API has a limit of 20 concurrent connections and a hard timeout of 600 seconds per request.    To start using this API, you will need your Access Token (available <a target=\"_blank\" href=\"https://app.elasticemail.com/marketing/settings/new/manage-api\">here</a>). Remember to keep it safe. Required access levels are listed in the given request’s description.    Downloadable library clients can be found in our Github repository <a target=\"_blank\" href=\"https://github.com/ElasticEmail?tab=repositories&q=%22rest+api%22+in%3Areadme\">here</a>

    The version of the OpenAPI document: 4.0.0
    Contact: support@elasticemail.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictFloat, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional, Union
from ElasticEmail.models.email_predicted_validation_status import EmailPredictedValidationStatus
from ElasticEmail.models.email_validation_status import EmailValidationStatus
from typing import Optional, Set
from typing_extensions import Self

class EmailValidationResult(BaseModel):
    """
    EmailValidationResult
    """ # noqa: E501
    account: Optional[StrictStr] = Field(default=None, description="Local part of an email", alias="Account")
    domain: Optional[StrictStr] = Field(default=None, description="Name of selected domain.", alias="Domain")
    email: Optional[StrictStr] = Field(default=None, description="Full email address that was verified", alias="Email")
    suggested_spelling: Optional[StrictStr] = Field(default=None, description="Suggested spelling if a possible mistake was found", alias="SuggestedSpelling")
    disposable: Optional[StrictBool] = Field(default=None, description="Does the email have a temporary domain", alias="Disposable")
    role: Optional[StrictBool] = Field(default=None, description="Is an email a role email (e.g. info@, noreply@ etc.)", alias="Role")
    reason: Optional[StrictStr] = Field(default=None, description="All detected issues", alias="Reason")
    date_added: Optional[datetime] = Field(default=None, description="Added date", alias="DateAdded")
    result: Optional[EmailValidationStatus] = Field(default=None, alias="Result")
    predicted_score: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="Predicted score", alias="PredictedScore")
    predicted_status: Optional[EmailPredictedValidationStatus] = Field(default=None, alias="PredictedStatus")
    __properties: ClassVar[List[str]] = ["Account", "Domain", "Email", "SuggestedSpelling", "Disposable", "Role", "Reason", "DateAdded", "Result", "PredictedScore", "PredictedStatus"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of EmailValidationResult from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of EmailValidationResult from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "Account": obj.get("Account"),
            "Domain": obj.get("Domain"),
            "Email": obj.get("Email"),
            "SuggestedSpelling": obj.get("SuggestedSpelling"),
            "Disposable": obj.get("Disposable"),
            "Role": obj.get("Role"),
            "Reason": obj.get("Reason"),
            "DateAdded": obj.get("DateAdded"),
            "Result": obj.get("Result"),
            "PredictedScore": obj.get("PredictedScore"),
            "PredictedStatus": obj.get("PredictedStatus")
        })
        return _obj


